#include "B4RDefines.h"
#include "Controllino.h"
#include "SPI.h"

namespace B4R {

	Byte B4RCONTROLLINO::Init() {
		Controllino_RTC_init();
	}	
		
	Byte B4RCONTROLLINO::SetTimeDate(Byte aDay, Byte aWeekDay, Byte aMonth, Byte aYear, Byte aHour, Byte aMinute, Byte aSecond) {
		Controllino_SetTimeDate(aDay, aWeekDay, aMonth, aYear, aHour, aMinute, aSecond);
	}	
	
	Byte B4RCONTROLLINO::SetTimeDateStrings(ArrayByte* aDate, ArrayByte* aTime) {
		Controllino_SetTimeDateStrings((Byte*) aDate->data, (Byte*) aTime->data);
	}	

	Byte B4RCONTROLLINO::GetDay() {
		return Controllino_GetDay();
	}	
		
	Byte B4RCONTROLLINO::GetWeekDay() {
		return Controllino_GetWeekDay();
	}		
		
	Byte B4RCONTROLLINO::GetMonth() {
		return Controllino_GetMonth();
	}		
	
	Byte B4RCONTROLLINO::GetYear() {
		return Controllino_GetYear();
	}	
	
	Byte B4RCONTROLLINO::GetHour() {
		return Controllino_GetHour();
	}		

	Byte B4RCONTROLLINO::GetMinute() {
		return Controllino_GetMinute();
	}	

	Byte B4RCONTROLLINO::GetSecond() {
		return Controllino_GetSecond();
	}		
	
	Byte B4RCONTROLLINO::RTC_SPI_SLAVE_PIN_INIT() {
		return Controllino_RTCSSInit();
	}	
	
	Byte B4RCONTROLLINO::RTC_SPI_SLAVE_PIN_CONTROL(Byte mode) {
		return Controllino_SetRTCSS(mode);
	}		
	
	Byte B4RCONTROLLINO::RS485Init() {
		return Controllino_RS485Init();
	}	

	Byte B4RCONTROLLINO::RS485Init_with_BaudRate(long aBaudrate) {
		Controllino_RS485Init(aBaudrate);
	}	

	void B4RCONTROLLINO::RS485TxEnable() {
		Controllino_RS485TxEnable();
	}	
	
	void B4RCONTROLLINO::RS485RxEnable() {
		Controllino_RS485RxEnable();
	}	
	
	Byte B4RCONTROLLINO::SwitchRS485RE(Byte mode) {
		return Controllino_SwitchRS485RE(mode);
	}		
	
	Byte B4RCONTROLLINO::SwitchRS485DE(Byte mode) {
		return Controllino_SwitchRS485DE(mode);
	}		
	
	Byte B4RCONTROLLINO::PrintTimeAndDate() {
		return Controllino_PrintTimeAndDate();
	}		
	
	Byte B4RCONTROLLINO::ClearRTCAlarm() {
		Controllino_ClearAlarm();
	}	
	
	Byte B4RCONTROLLINO::SetRTCAlarm(Byte hour, Byte minute) {
		Controllino_SetAlarm(hour, minute);
	}	
	
	
	
		
	
	
/* 	void B4REEPROM_A::WriteBytes(ArrayByte* Src, UInt Position) {
		#ifdef ESP_H
			EEPROM_begin();
			for (UInt i = 0;i < Src->length;i++)
				EEPROM.write(Position + i, ByteFromArray(Src, i));
			EEPROM.commit();
		#else
			eeprom_update_block(Src->data, (void*)Position, Src->length);
		#endif
		
	}
	ArrayByte* B4REEPROM_A::ReadBytes(UInt Position, UInt Count) {
		ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
		arr->data = StackMemory::buffer + StackMemory::cp;
		StackMemory::cp += Count;
		arr->length = Count;
		ReadBytes2(Position, Count, arr);
		return arr;
	}
	void B4REEPROM_A::ReadBytes2(UInt Position, UInt Count, ArrayByte* Dest) {
		#ifdef ESP_H
			EEPROM_begin();
			for (UInt i = 0;i < Count;i++)
				((Byte*)Dest->data)[i] = EEPROM.read(Position + i);
		#else
			eeprom_read_block(Dest->data, (void*)Position, Count);
		#endif
		
	} */
	
}
